#####################################################################
# Copyright (C) 2000 Artur Trzewik
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
######################################################################
# Header
# CVS - $Id: Init.tcl,v 1.6 2001/01/06 14:50:04 artur Exp $
#
# Information: Anzeigen von Datenbank Tabellen als Tabelle
#

# 1. Factory fr erzeugen von Tabellenansichten aus DOM XML
# 2. Als Schnittstelle zwichten System (masterObject) und TkTable2.6 Extension
Class TableInterface -parameter {
    masterObject
}
TableInterface instproc create {mwin dom_node mrows} {
    [self] instvar win rows labels columns activerow
    set win $mwin
    set rows $mrows
    set activerow -2
    set row_nodes [$dom_node selectNodes child::row]
    set columns [llength $row_nodes]
    set widthpar {-1 5}
    set x 0 
    foreach row_node $row_nodes {
	lappend labels [$row_node getAttribute label]
	if {[$row_node hasAttribute textwidth]} {
	    lappend widthpar $x
	    lappend widthpar [$row_node getAttribute textwidth]
	}
	incr x
    }
    frame $win
    
    
    table $win.t -cols [expr {$columns+1}] -rows $rows \
	-usecommand 1 -cache 1 \
	-command "[self] cmdcell %r %c %i %s" \
	-browsecommand "[self] setactive %r %c" \
	-yscrollcommand "$win.sy set" -xscrollcommand "$win.sx set" \
	-selecttype cell -multiline 0 \
	-titlerows 1 -titlecols 1 \
	-roworigin -1 -colorigin -1 \
	-height [$dom_node getAttribute height] \
	-width [$dom_node getAttribute width]

 
    eval $win.t width $widthpar

    scrollbar $win.sy -command [list $win.t yview]
    scrollbar $win.sx -command [list $win.t xview] -orient horizontal
 
    grid $win.t -row 0 -column 0 -sticky news
    grid $win.sy -row 0 -column 1 -sticky ns
    grid $win.sx -row 1 -column 0 -sticky ew
    grid columnconfig $win 0 -weight 1
    grid rowconfig $win 1 -weight 1
}
TableInterface instproc cmdcell {row column mode value} {
    [self] instvar labels
    puts "gets $row $column $mode $value"
    if {$row==-1} {
	return [lindex $labels [expr $column]]
    }
    if {$column==-1} {
	return $row
    }
    return "$row $column"
}
TableInterface instproc setactive {row column} {
    [self] instvar activerow lrow lcolumn lvalue win
    if {$row!=$activerow} {
	set activerow $row
    }
    set lrow $row
    set lcolumn $column
    set lvaue [$win.t get $row,$column]
}
TableInterface instproc validatecmd {row column value} {
    puts "$row $column $value"
    return 1
}
